Public Class FrmInput2
    REM variables public a la feuille (classe)
    Dim treg() As String = {"Auvergne", "Bordelais", "Bretagne", "Morvan", "Nord", "Normandie", "Paris", "Poitou"}
    Dim ctro As Integer     REM Compteur d'oral choisit.
    Dim ctre As Integer     REM Idem pour les ecrits.

    Private Sub FrmIsc3_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer REM Utilise les tableaux pour la compositions des for
        Dim CB As CheckBox REM pour les for checkbox

        For i = 0 To UBound(treg)           REM Charge la liste des rgions
            CboRegion.Items.Add(treg(i))
        Next
        i = 0
        For Each CB In GBOral.Controls      REM Charge l'oral
            CB.Text = tme(i)
            If i = 8 Then Exit For
            i += 1
        Next
        i = 3
        For Each CB In GBEcrit.Controls     REM Charge l'crit
            CB.Text = tme(i)
            i += 1
        Next
        If Boule = True Then          REM edition
            Me.Tag = "Assistant dition de candidature (3/4)"

            LblNP.Text = Format(Selectedclef, "00") & " - " & Tindex(Selectedclef - 2).nom & " " & Tindex(Selectedclef - 2).prenom   REM Ajoute l'identifiant en cas de modifications.
            CboRegion.SelectedIndex = cddts.Region

            'For i = 0 To 3
            '    MsgBox("Ecrit(" & i & ") = " & FrmAccueil.cddts.Ecrit(i) & " -> " & tme(FrmAccueil.cddts.Ecrit(i)))
            'Next
            'For i = 0 To 3
            '    MsgBox("Oral(" & i & ") = " & FrmAccueil.cddts.Oral(i) & " -> " & tme(FrmAccueil.cddts.Oral(i)))
            'Next

            For Each CB In GBEcrit.Controls      REM Recompose les CheckBox ECRITS
                For i = 0 To 3
                    If CB.Text = tme(cddts.Ecrit(i)) Then CB.Checked = True
                Next
            Next
            For Each CB In GBOral.Controls      REM Recompose les CheckBox ORAUX
                For i = 0 To 2
                    If CB.Text = tme(cddts.Oral(i)) Then CB.Checked = True
                Next
            Next

            REM Retrouve l'examen facultatif
            If cddts.Fac = Nothing Then
                RBno.Checked = True
            Else
                RBYes.Checked = True
                For i = 0 To CboFac.Items.Count - 1
                    If CboFac.Items.Item(i) = tme(cddts.Fac) Then
                        CboFac.SelectedIndex = i
                    End If
                Next
                CboFac.SelectedIndex = tme(IndexFac)
            End If

        End If
        If Boule = False Then        REM inscription
            Me.Tag = "Assistant cration de candidature (3/4)"
            LblNP.Text = FrmInput1.TxtNom.Text & " " & FrmInput1.TxtPrenom.Text    REM Reprend le nom et le prnom depuis la feuille input1.
            LblCaR.Tag = 75
            RBno.Checked = True
            PnlFac.Visible = False
            CboRegion.SelectedIndex = 0 REM met premier en tte...
        End If
        Me.Text = Me.Tag & " | " & Horaire & " | Temps restant : 1:15"
        TmrCaR.Start() REM timer start
    End Sub




    Private Sub CmdAnnul_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdAnnul.Click
        TmrCaR.Stop() REM fin timmer
        FrmEdit.Close() REM ferme toutes les fentres...
        FrmNouv.Close()
        FrmInput1.Close()
        Me.Close()
        FrmAccueil.Show() REM retour a l'accueil
    End Sub

    Private Sub TmrCaR_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TmrCaR.Tick
        LblCaR.Tag -= 1
        If LblCaR.Tag >= 60 Then
            Me.Text = Me.Tag & " | " & Horaire & " | Temps restant : 1:" & Format(LblCaR.Tag - 60, "00")
        End If
        If LblCaR.Tag < 60 And LblCaR.Tag > 0 Then
            Me.Text = Me.Tag & " | " & Horaire & " | Temps restant : " & LblCaR.Tag
        End If
        If LblCaR.Tag = 0 Then
            Me.Text = Me.Tag & " | " & Horaire
        End If
        If LblCaR.Tag <= 1 Then
            LblCaR.Text = "Vous disposez de " & LblCaR.Tag & " seconde restante."
        End If
        If LblCaR.Tag > 61 Then
            LblCaR.Text = "Vous disposez d'une minute et " & LblCaR.Tag - 60 & " secondes restantes."
        End If
        If LblCaR.Tag = 61 Then
            LblCaR.Text = "Vous disposez d'une minute et " & LblCaR.Tag - 60 & " seconde restante."
        End If
        If LblCaR.Tag <= 60 And LblCaR.Tag <> 1 Then
            LblCaR.Text = "Vous disposez de " & LblCaR.Tag & " secondes restantes."
        End If
        If LblCaR.Tag <= 10 Then
            LblCaR.ForeColor = Color.Red
        End If
        If LblCaR.Tag <= 0 Then
            TmrCaR.Stop()
            LblCaR.Text = "Le temps impartie est coule."
            MsgBox("Le temps impartie est coul. L'inscription a chou.", MsgBoxStyle.Exclamation, "Echec")
            FrmEdit.Close()
            FrmInput1.Close()
            FrmNouv.Close()
            Me.Close()
            FrmAccueil.Show()
        End If
    End Sub

    Private Sub CmdNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdNext.Click
        'Dim OK As Boolean
        Dim i As Integer = 0

        REM Convertit l'index du combobox en l'quivalent du tableau tme, et le stocke dans IndexFac, pour la sauvegarde.
        For i = 0 To UBound(tme)
            If CboFac.SelectedItem = tme(i) Then
                IndexFac = i
                Exit For
            End If
        Next
        If ctre + ctro = 7 Then
            TmrCaR.Stop()
            Me.Hide()
            FrmInput3.Show()
        Else : MsgBox("Vous devez choisir 4 examens crits et 3 examens oraux. (Vous pouvez ds lors choisir des examens facultatifs)", MsgBoxStyle.Exclamation, "Inscription incorrecte")
        End If
    End Sub

    Sub convfac(ByVal index)
        Dim i As Integer
        For i = 0 To UBound(tme)
            If CboFac.SelectedItem = tme(i) Then Exit For
        Next
    End Sub

    Private Sub CmdDelet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim quit As Integer
        quit = MsgBox("Vous tes sur le point de supprimer une candidature. Voulez-vous continuer ?", MsgBoxStyle.YesNo + MsgBoxStyle.Question, "Suppression d'un candidat")
        If quit = 6 Then
            MsgBox("Le Candidat a bien t supprim.", MsgBoxStyle.Information, "Information")
            FrmEdit.Close()
            FrmNouv.Close()
            FrmInput1.Close()
            Me.Close()
            FrmAccueil.Show()
        End If
    End Sub

    'Private Sub CmdPre_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    REM retour au prcdent
    '    Me.Hide()
    '    FrmInput1.Show()
    'End Sub

    Private Sub RB_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RBno.CheckedChanged
        If RBno.Checked Then
            LblFac2.Visible = False
            CboFac.Visible = False
            GBEcrit.Enabled = True
            GBOral.Enabled = True
        End If
    End Sub

    REM Dans le panel pour les examens facultatifs
    Private Sub RBYes_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RBYes.CheckedChanged
        If RBYes.Checked Then
            LblFac2.Visible = True
            CboFac.Items.Clear()        REM Efface la liste des exams facultatifs
            Dim Chb As CheckBox
            For Each Chb In GBEcrit.Controls        REM Construit la liste des exams facultatifs. Il est plus intelligent de le mettre l plutt que dans la fonction DeclencheurdeFacultatif car il est recalcul aprs avoir choisit la possibilit des examens, et non a chaque clique des cases. De plus, ca pose un problme de reset.
                If Not Chb.Checked And Chb.Enabled Then CboFac.Items.Add(Chb.Text)
            Next
            If CheckBox18.Checked = False Then CboFac.Items.Add(CheckBox18.Text)
            If CheckBox17.Checked = False Then CboFac.Items.Add(CheckBox17.Text)
            If CheckBox16.Checked = False Then CboFac.Items.Add(CheckBox16.Text)
            CboFac.Visible = True
            CboFac.SelectedIndex = 0 REM met premier en tte...
            GBEcrit.Enabled = False
            GBOral.Enabled = False
        End If
    End Sub

    Private Sub SecureEcritMAX4(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged, CheckBox2.CheckedChanged, CheckBox3.CheckedChanged, CheckBox4.CheckedChanged, CheckBox5.CheckedChanged, CheckBox6.CheckedChanged, CheckBox7.CheckedChanged, CheckBox8.CheckedChanged, CheckBox9.CheckedChanged, CheckBox10.CheckedChanged, CheckBox11.CheckedChanged, CheckBox12.CheckedChanged
        If sender.checkstate = CheckState.Checked Then
            ctre += 1
            If ctre > 4 Then
                MsgBox("Vous ne pouvez pas choisir plus de 4 examens ecrits.", MsgBoxStyle.Exclamation, "Trop de choix")
                sender.checkstate = CheckState.Unchecked
            End If
        Else
            ctre -= 1
        End If

        DeclencheurDeFacultatif() REM Appelle la fonction qui dclenche l'affichage du choix de l'exam facultatif

        REM Regule l'affichage du nombre d'examen choisit.
        If ctre = 0 Then
            LblNbEcr.Text = ""
        ElseIf ctre = 1 Then
            LblNbEcr.Text = ctre & " examen crit choisit sur 4."
        Else
            LblNbEcr.Text = ctre & " examens crits choisit sur 4."
        End If
    End Sub

    Private Sub SecureOralMAX3(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox13.CheckedChanged, CheckBox14.CheckedChanged, CheckBox15.CheckedChanged, CheckBox21.CheckedChanged, CheckBox20.CheckedChanged, CheckBox19.CheckedChanged, CheckBox18.CheckedChanged, CheckBox17.CheckedChanged, CheckBox16.CheckedChanged
        If sender.checkstate = CheckState.Checked Then
            ctro += 1
            If ctro > 3 Then
                MsgBox("Vous ne pouvez pas choisir plus de 3 examens oraux.", MsgBoxStyle.Exclamation, "Trop de choix")
                sender.checkstate = CheckState.Unchecked
            End If
        Else
            ctro -= 1
        End If

        DeclencheurDeFacultatif()
        If ctro = 0 Then
            LblNbOral.Text = ""
        ElseIf ctro = 1 Then
            LblNbOral.Text = ctro & " examen oral choisit sur 3."
        Else
            LblNbOral.Text = ctro & " examens oraux choisit sur 3."
        End If
    End Sub

    Private Sub ChageAllemand(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox12.CheckedChanged, CheckBox21.CheckedChanged
        CheckBox21.Enabled = Not CheckBox12.Checked     REM Active/Dsactive la ChB de l'oral en fonction de l'tat de la ChB de l'crit.
        CheckBox12.Enabled = Not CheckBox21.Checked     REM Idem mais en fonction de l'oral
    End Sub

    Private Sub ChangeAnglais(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox11.CheckedChanged, CheckBox20.CheckedChanged
        CheckBox20.Enabled = Not CheckBox11.Checked     REM Active/Dsactive la ChB de l'oral en fonction de l'tat de la ChB de l'crit.
        CheckBox11.Enabled = Not CheckBox20.Checked     REM Idem mais en fonction de l'oral
    End Sub

    Private Sub ChangeAstronomie(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox10.CheckedChanged, CheckBox19.CheckedChanged
        CheckBox19.Enabled = Not CheckBox10.Checked     REM Active/Dsactive la ChB de l'oral en fonction de l'tat de la ChB de l'crit.
        CheckBox10.Enabled = Not CheckBox19.Checked     REM Idem mais en fonction de l'oral
    End Sub

    Private Sub ChangeEspagnol(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox9.CheckedChanged, CheckBox15.CheckedChanged
        CheckBox15.Enabled = Not CheckBox9.Checked     REM Active/Dsactive la ChB de l'oral en fonction de l'tat de la ChB de l'crit.
        CheckBox9.Enabled = Not CheckBox15.Checked     REM Idem mais en fonction de l'oral
    End Sub

    Private Sub ChangeHistoire(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox8.CheckedChanged, CheckBox14.CheckedChanged
        CheckBox14.Enabled = Not CheckBox8.Checked     REM Active/Dsactive la ChB de l'oral en fonction de l'tat de la ChB de l'crit.
        CheckBox8.Enabled = Not CheckBox14.Checked     REM Idem mais en fonction de l'oral
    End Sub

    Private Sub ChangeRusse(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox7.CheckedChanged, CheckBox13.CheckedChanged
        CheckBox13.Enabled = Not CheckBox7.Checked     REM Active/Dsactive la ChB de l'oral en fonction de l'tat de la ChB de l'crit.
        CheckBox7.Enabled = Not CheckBox13.Checked     REM Idem mais en fonction de l'oral
    End Sub

    Private Sub DeclencheurDeFacultatif()
        If ctre + ctro = 7 Then     REM Affiche les facultatifs aprs avoir coch tout les examens obligatoire
            PnlFac.Visible = True
        Else                        REM Cache tout.
            PnlFac.Visible = False
        End If
    End Sub


End Class